package org.elsysbg.objectDetectionTools;

import java.util.Comparator;

public class Blob {
	public int xMin;
	public int xMax;
	public int yMin;
	public int yMax;
	public int mass;
	public int label;

	/**
	 * Construct a new blob from given parameters
	 * @param xMin
	 * @param xMax
	 * @param yMin
	 * @param yMax
	 * @param mass
	 * @param label
	 */
	public Blob(int xMin, int xMax, int yMin, int yMax, int mass, int label) {
		this.xMin = xMin;
		this.xMax = xMax;
		this.yMin = yMin;
		this.yMax = yMax;
		this.mass = mass;
		this.label = label;
	}
	
	/**
	 * Overrides the default toString() method of class Object
	 */
	public String toString(){
		return String.format(
				"X:%4d -> %4d,  Y:%4d -> %4d,  mass: %6d,  label: %d",
				xMin,xMax,yMin,yMax,mass,label);
	}
	/**
	 * compare masses of two blobs
	 * @author julls
	 *
	 */
	public static class BlobMassComparator implements Comparator<Blob> {
		@Override
		public int compare(Blob blob1, Blob blob2) {
			return blob2.mass - blob1.mass;
		}

	}

	
	public static class BlobOrderComparator implements Comparator<Blob> {
		@Override
		public int compare(Blob blob1, Blob blob2) {
			return blob1.xMin - blob2.xMin;
		}		
	}
}
