package org.elsysbg.objectDetectionTools;

import java.awt.Color;
import java.io.IOException;

import org.elsysbg.objectDetectionTools.Basic;;

public class ChannelFilterThreshold extends Basic {

	LABColor white = new LABColor (255,255,255);
	
	public ChannelFilterThreshold(String basedir, int index){
		super(basedir, index);
	}
	
	public void filterAndThreshold() throws IOException{
		openInOutFile("inbox","","jpg");
		
		bufOut= bufIn;
		saveOutFile("outbox", "_original", "bmp");
		
		openInOutFile("inbox", "", "jpg");
		filter();
		saveOutFile("outbox", "_filter", "bmp");
		closeInFile();
	}
	
	private void filter(){
		for (int i = 0; i < bufIn.getWidth(); i++){
			for (int j = 0; j < bufIn.getHeight(); j++){
				int rgb = 0;
								
				LABColor color = new LABColor(new Color(bufIn.getRGB(i, j)));
				
				double dist = white.getDifference1976(color);
				
				if (dist > 60){
					rgb = 0x000000; //black
				}
				else{
					rgb = 0xffffff; //white
				}
				setPixel(i, j, rgb);
			}
		}
	}
	
	private void setPixel(int i, int j, int val){
		if (belowThreshold(val)){// < 128
			bufOut.setRGB(i, j, 0x00ffffff);//this is white //AARRGGBB - alpha, red, green,blue
		}
		else{// >= 128
			bufOut.setRGB(i, j, 0); // Black
		}
	}
	private boolean belowThreshold(int i){
		return (i & 0xff) < 128;
	}
	
}
