package org.elsysbg.objectDetectionTools;

import java.io.File;

public class DropBox {
	private String baseDirectory;

	public DropBox(String baseDirectory) {
		this.baseDirectory = baseDirectory;
	}
	
	/**
	 * this method copy files from dropbox to inbox
	 * and than delete the files, that are copied, from dropbox
	 */
	public void copyAndDeleteFromDropBox(){
		int newIndex = getFilesIn("inbox").length;
		String[] dropboxFiles = getFilesIn("dropbox");
		for(int i=0;i<dropboxFiles.length; i++){
			process(dropboxFiles[i], ++newIndex);
		}
	}
	
	/**
	 * list the files in dir
	 * @param dir
	 * @return
	 */
	private String[] getFilesIn(String dir){
		File dire = new File(baseDirectory + "\\" + dir);
		return dire.list();
	}
	
	/**
	 * method that moves a file from the dropbox to the inbox
	 * @param file - the file we want to move
	 * @param index - the index that the file will be saved with
	 */
	private void process(String file, int index){
		File from = new File(baseDirectory + "\\dropbox\\" + file);
		File to = new File(baseDirectory+"\\inbox\\plate"+Convert.convertToString(index)+".jpg");
		from.renameTo(to);
	}
	

}
