package org.elsysbg.objectDetectionTools;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;



public class Recognizer extends Basic {
	private StringBuffer sb;

	public Recognizer(String baseDirectory, int indexOfFile) {
		super(baseDirectory, indexOfFile);
	}
	
	public void recognize() throws IOException{
		DropBox db = new DropBox(baseDirectory);
		db.copyAndDeleteFromDropBox();
		ChannelFilterThreshold cft = new ChannelFilterThreshold(baseDirectory, index);
		cft.filterAndThreshold();
		Segmenter seg = new Segmenter(baseDirectory, index, 0.05);
		seg.segment();
		Scaler s = new Scaler(baseDirectory, index);
		s.scale();
		match();
		
	}
	
	private char lookup(int i){
		if(i<26)
			return (char)(i+65); // return letters
		if(i<36)
			return (char)(i+48-26); // return numbers
		return ' ';
	}
	
	private char match(int segmentNumber) throws IOException{
		int min = Integer.MAX_VALUE;
		int minindex = -1;
		for(int i= 0; i< 36; i++){ //through all templates
			BufferedImage segnobuf = ImageIO.read(new File(
					baseDirectory+"\\outbox" + "\\plate"+ index + "\\plate_scale"
					+segmentNumber+ "" + Convert.convertToString(index)+".bmp"));
			int d = distance(segnobuf, i);
			if(d<min){ // where the distance is minimal or....where the images are most the same
				min= d;
				minindex = i;//we take the number of the template
			}
		}
		System.out.println("min index " + minindex);
		return lookup(minindex);//and then return the letter or number on the template 
	}
	
	private int distance(BufferedImage segmnobuf, int templateNumber) throws IOException{
		int d= 0;
		BufferedImage templateBuf = ImageIO.read(new File(baseDirectory + 
				"\\templates\\" + lookup(templateNumber)+"__.bmp"));
		
		//here we iterate all over the pixels of the input image 
		//and compare the color of the pixels with the template image
		for(int i=0; i< segmnobuf.getWidth(); i++){
			for (int j = 0; j<segmnobuf.getHeight(); j++){
				if(segmnobuf.getRGB(i, j) - templateBuf.getRGB(i, j)!=0){
					d++;
				}
			}
		}
		return d;
	}
	
	/**
	 * public function for matching n times..
	 * @throws IOException 
	 */
	private void match() throws IOException{
		sb = new StringBuffer();
		for (int i = 1; i <= 8; i++) {
			sb.append(match(i));
		}

		System.out.println(sb);
		
	}
}
