package org.elsysbg.objectDetectionTools;

import java.io.IOException;

/**
 * Extends Basic
 * @author julls
 *
 */
public class Scaler extends Basic {

	private int top, right, bottom, left;
	
	public Scaler(String baseDirectory, int indexOfFile) {
		super(baseDirectory, indexOfFile);
	}

	/**
	 * it calculates top,bottom,right and left starting points
	 * and save new image with size 65x80
	 * 
	 * @param segmentNumber which image we want to scale
	 * @throws IOException
	 */
	private void scale (int segmentNumber) throws IOException{
		openInOutFile("outbox", "_"+segmentNumber+ "seg", "bmp", 65, 80);
		//top
		top = 0;
		boolean found = false;
		for (int j=0;j<bufIn.getHeight() && !found ; j++){
			for (int i=0;i<bufIn.getWidth() && !found;i++){
				found= (bufIn.getRGB(i, j) & 0x00ffffff) != 0;
				if (found)
					top = j;
			}
		}
		//bottom
		bottom = 0;
		found= false;
		for (int j = bufIn.getHeight()-1; j >=0 && !found; j--) {
			for(int i =0; i<bufIn.getWidth() && !found ; i++){
				found = (bufIn.getRGB(i, j) & 0x00ffffff) != 0;
				if(found)
					bottom = j;
			}
		}
		//left
		found = false;
		for(int i=0;i<bufIn.getWidth() && !found; i++){
			for(int j=0;j<bufIn.getHeight() && !found; j++){
				found =(bufIn.getRGB(i, j) & 0x00ffffff) !=0;
				if(found)
					left = i;
			}
		}
		
		//right
		found = false;
		for(int i=bufIn.getWidth()-1;i>=0 && !found;i--){
			for(int j=0;j<bufIn.getHeight() && !found;j++){
				found = (bufIn.getRGB(i, j) & 0x00ffffff) != 0;
				if (found)
					right = i;
			}
		}
		
		int hy = bottom - top;
		int hx = right - left;
		
		for(int s = 0; s<65; s++){
			for(int t = 0; t<80; t++){
				int x = (int) Math.round(left+(2*hy*s - 65*hy +64*hx)/128.0);
				//left + hx/2 +(hy/64)(s-(65-s))/2
				int y = (int) Math.round(top+ (hy/64.0) * (t-8.0));
				int rgb;
				if(x<0 || y<0 || x>=bufIn.getWidth() 
						|| y>=bufIn.getHeight()){
					rgb = 0;
				}else{
					rgb = bufIn.getRGB(x, y);
				}
				bufOut.setRGB(s, t, rgb);
			}
		}
		saveOutFile("outbox", "_scale" +segmentNumber, "bmp");
		
	}
	
	/**
	 * save 8 new images with needed letters and numbers
	 * @throws IOException
	 */
	public void scale() throws IOException{
		for(int i=1;i<=8;i++){
			scale(i);
		}
	}
}
